#ifndef ITEM_HPP
#define ITEM_HPP

#include <string>

class Item // rendelsi ttel
{
public:
    virtual ~Item() {} // virtulis destruktor
    virtual int getNetValue() const
    {
        return getTotalValue() * 0.8;    // nett rtk lekrdezse
    }
    virtual int getTotalValue() const = 0; // brutt rtk lekrdezse
    virtual char getType() const = 0; // tpus lekrdezse
    virtual std::string getName() const = 0; // nv lekrdezse
};

class Hamburger : public Item
{
public:
    Hamburger(std::string n, int v) : _totalValue(v), _name(n) {}
    int getTotalValue() const
    {
        return _totalValue;
    }
    char getType() const
    {
        return 'h';
    }
    std::string getName() const
    {
        return _name;
    }
private:
    int _totalValue;
    std::string _name;
};

class Ufo : public Item
{
public:
    Ufo(std::string n, int v) : _totalValue(v), _name(n) {}
    int getTotalValue() const
    {
        return _totalValue;
    }
    char getType() const
    {
        return 'h';
    }
    std::string getName() const
    {
        return _name;
    }
private:
    int _totalValue;
    std::string _name;
};

class Pancake : public Item
{
public:
    Pancake(std::string n, int v) : _totalValue(v), _name(n) {}
    int getTotalValue() const
    {
        return _totalValue;
    }
    char getType() const
    {
        return 'u';
    }
    std::string getName() const
    {
        return _name;
    }
private:
    int _totalValue;
    std::string _name;
};

class Tea : public Item
{
public:
    Tea() {}
    int getTotalValue() const
    {
        return 200;
    }
    char getType() const
    {
        return 't';
    }
    std::string getName() const
    {
        return "tea";
    }
};

class Orange : public Item
{
public:
    Orange() {}
    int getTotalValue() const
    {
        return 250;
    }
    char getType() const
    {
        return 'o';
    }
    std::string getName() const
    {
        return "narancsl";
    }
};

class Coke : public Item
{
public:
    Coke() {}
    int getTotalValue() const
    {
        return 300;
    }
    char getType() const
    {
        return 'k';
    }
    std::string getName() const
    {
        return "kla";
    }
};

#endif // ITEM_HPP
