#ifndef MENU_HPP
#define MENU_HPP

#include "vector.hpp"
#include "order.hpp"

class Menu // menü
{
public:
    void run(); // menü futtatása
    void loadData(); // adatok betöltése
    void saveData() const; // adatok mentése
private:
    void showMainMenu() const; // főmenü megjelenítése
    void showOrdersMenu() const; // rendelések kiírása
    void showOrder(int nr) const; // egy rendelés kiírása
    void showOrdersForCard(int nr) const; // egy törzsvásárló rendeléseinek kiírása
    void showStatisticsMenu() const; // statisztikák menü megjelenítése
    void showStatisticsForAll() const; // összes rendelés statisztikája
    void showStatisticsForCard(int cardNr) const; // törzsvásárlói statisztika

    void addOrder(); // új rendelés felvétele

    vector<Order> _orders; // rendelések
};

#endif // MENU_HPP
